-- multiplexer

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity mux is
  generic(nr_din: integer; -- number of inputs 
          dwidth: integer; -- width of the data (of each input and output
          sel_width: integer); -- width of the select signal
  port (din: in std_logic_vector(0 to nr_din*dwidth-1); -- input data
        sel: in std_logic_vector(0 to sel_width-1); -- select 
        dout: out std_logic_vector(0 to dwidth-1)); -- output data
end mux;


architecture arch of mux is
  begin
process(sel, din) begin
  for i in 0 to 2**sel_width-1 loop
    if sel=i then
      if i<nr_din then
        dout<= din(i*dwidth to (i+1)*dwidth-1);
      else
        dout<= (others=>'-');
      end if;
    end if;  
  end loop;
end process;
end arch;
  
  